#import <CoreData/CoreData.h>
#if TARGET_OS_IPHONE
	#import "NSManagedObjectContext_ext.h"
	#import "NSManagedObject_ext.h"
	#import "mymacros.h"
#else
	#import <OnFlAppFoundation/OnFlAppFoundation.h>
#endif

@interface __MYDataStore : NSObject {
	NSString* dataName;
	NSString* dataType;
	NSString* appName;
	
	NSTimeInterval lastmdate;
	NSURL* dataurl;
	
	NSManagedObjectModel *managedObjectModel;
	NSManagedObjectContext *managedObjectContext;
	NSPersistentStoreCoordinator *persistentStoreCoordinator;
}
- (id) initWithName:(NSString*) nm andType:(NSString*) tp;
- (NSString *) applicationDocumentsDirectory;
- (NSPersistentStoreCoordinator*) persistentStoreCoordinator;
- (NSManagedObjectContext*) managedObjectContext;
- (NSManagedObjectModel*) managedObjectModel;
- (void) __setAppName:(NSString*) nm;
- (void) save;

@end

@interface MYDataStore : NSObject {
	__MYDataStore* mydatastore;
}
+ (__MYDataStore*) existingSharedInstance;
+ (__MYDataStore*) sharedInstance;
- (NSManagedObjectContext*) managedObjectContext;
- (void) setDataStoreName:(NSString*) nm;

- (IBAction) save:(id) sender;

@end

static __MYDataStore* __mydatastore__;

@interface MYDataStoreFallbackTransformer : NSValueTransformer
@end
